c         
c         
       subroutine cgnlp(a, ntp, icon)
c     ********************************************************
c            a: /ptcl/    Output. to get produced particles in cms
c          ntp:  output.  Integer. The number of particle in a.
c         icon:  Integer. Output.0--> o.k
c                                1--> n.g
       implicit none
#include  "Zptcl.h"
#include  "Zmass.h"
#include  "Zevhnv.h"
c
       record /ptcl/ a(*)
       integer ntp, icon
c      -------------------------------- 
       real*8   missgm, roots
       integer jcon
c


c       integer maxiso/10/  ! max # of ptcl from isotropic p.s   
       integer maxiso/0/  ! max # of ptcl from isotropic p.s   
c       logical ok
c
c              sample # of charged ptcls
c
       missgm = Missingp.mass
       roots =  Cmsp.mass
c        *** until loop*** 

       do while (.true.)
c                get average # and sampled # of charged ptcl
c                Avncharged & Nch
          call csnchp(jcon)
          if(jcon .ne. 0) then
             icon=1
             goto 900           ! return
          endif
c              fix # of pi+-, pi0, k+-,k0, nn~, dd~,
c              and give ptcl mass and code in a;
c              # of pi+- etc is obtained by calling
c              cqnptc(code, charge, nout)
          call cfnptc(a,  ntp)
           if(ntp .ge. 1 ) goto 10
c           if(ntp .eq. 1 .and. missgm .lt. 15.*maspic) goto 10
c           if(ntp .eq. 2 .and. missgm .lt. 30.*maspic) goto 10
       enddo
 10    continue
       if(ntp .le. maxiso .and. ntp .ge. 2) then
c               use isotripc p.s
            call ciso(ntp, a, icon)
            if(icon .eq. 1) then
c                   <Pt> is too large so use cylindrical p.s
               call ccylps(ntp, a, icon)
            elseif(icon .eq. 2) then
                icon=1
            endif
        elseif(ntp .ge. 2) then
            call ccylps(ntp,  a, icon)
        else
c              assume 1 (or 0) pion production in cms
            call c1pion(a, ntp, icon)
        endif
  900  continue
       end
c     *****************************
      subroutine ccpmul(roots, avn)
c     *****************************
c      average charged particle multiplicity at root(s)
c     /**** UA5 parameterization ***/
c      root(s)  GeV
       implicit none
#include "Zevhnp.h"

       real*8 roots, avn
c       real*8 lambda/0.3/, no/0.34/, qcdErg/73./
c       real*8 lambda/0.3/, no/0.6135/, qcdErg/1000./  ! up to 1000 GeV.
c                              | this is wrong (total  multiplicity)
       real*8 lambda/0.3/, no/0.315/, qcdErg/1000./  ! up to 1000 GeV.
c                           
c                we use UA5 data.

c                   original
c       avn= 7.2* roots**(2*0.127) -7.   including  leading.
c
c       if(roots .lt. 32.) then
       if(roots .lt. 50.) then
c          avn= 7.2* roots**(2*0.1) - 7
c          avn= 0.9 * roots**0.65
c           avn= 1.3 * roots**0.55
c           avn= 1.1 * roots**0.6
           avn= 1.25 * roots**0.55
       elseif(roots .gt. qcdErg .and. MulLow .eq. 1) then
c             2.5 is cosmos adjusting factor. (2 is leading)
          avn = no* exp(sqrt(23./18. * log( (roots/lambda))*2))
     *          -2.5
       else
c           all graphs have been draw with this 
c           one can fit ua5 non-single diffrective data, but 
c           it is not the data to be fitted. used before uv.3.00 
c           mistakenly.
c          avn= 7.2* roots**(2*0.127) - 8.0  ! 2.5 for adj. 2 is leading
c               too strong power.  very good at root s = 53 
c          avn= 6.9* roots**(2*0.127) - 8.0  ! 2.5 for adj. 2 is leadingc 
c               finally adopeted
           avn= 7.1* roots**(2*0.124) - 8.0  ! 2.5 for adj. 2 is leading
c           avn= 6.8 * roots**(2*0.124) - 8.0  ! 2.5 for adj. 2 is leading
       endif
c           at roots > 50 GeV, we may try a QCD prediction like
c           avn = N * exp(sqrt(23./18. * log( (roots/lamda))*2 ))
c         with N = 0.34 and lamda=0.3 (GeV).  this give 
c         slightly smaller number than the above one at Elab > 400 TeV
c
c
      end
c      **************ccylps**************************************
c           generation of ptcls by cylindrical p.s
c         icon:  0---> o.k
c                1---> n.g
c      ****************************************************
       subroutine ccylps(ntp, a, icon)
       implicit none
c----       include  '../../Zptcl.h'
#include  "Zptcl.h"
c----       include  '../Zevhnv.h'
#include  "Zevhnv.h"
       integer ntp, icon
       record /ptcl/  a(ntp)
c
       real*8 ptav, w
       integer i
c
c          assign pt 
c              init for const.
         call caspti
c                            loc pt = loc pz
         call caspt(a, ntp)
c          pt---> ptx,pty
         call csptxy(a, ntp)
c            forced conservation of pt.
         call cptcns(a, ntp, ptav)
c           generation of rapidity for missing mass
         w = Missingp.mass
c                             loc tm = loc pz
c                             loc rap = loc e
         call cgrap(w, ptav, ntp,  a, icon)
         if(icon .eq. 0) then
c             convert y into to missing mass system energy
            call cytoe(a, ntp)
c           ________________________________
c           call cchk(' after cytoe', a, ntp)
c           ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c                boosting ntp ptcls to cms
             do   i=1, ntp
                call cibst1(i, Missingp, a(i), a(i))
             enddo
         endif
       end
c      ********************************************
c            generate 1 pion
c            leadings are reset here.
c          icon:  0--> o.k
c                 1--> n.g
       subroutine c1pion(a, ntp, icon)
c         Method:
c          Now, the recoil leadings and missing mass and its
c          4 momentum are given.  We change this missing mass
c          to be a pion and make a transformaton so that
c          3 particles satify the 4 momentum conservation.            
c       a(1): /ptcl/. Outupt. produced pion
c        ntp: integer. Output.  1  if icon =0 (produced)
c                               0  if icon =1 (n.g)
c       icon: integer. Output.  0--> ok. 1--> n.g
c      ********************************************
       implicit none
c----       include '../../Zptcl.h'
#include  "Zptcl.h"
c----       include '../../Zmass.h'
#include  "Zmass.h"
c----       include '../Zevhnv.h'
#include  "Zevhnv.h"
#include  "Zcode.h"

c
       integer ntp, icon
       record /ptcl/  a(*)

       record /ptcl/ p3(3)   ! to store 3 particles
       real*8 amu(3), roots, gzai
       integer  csum0, csum1, charge
       character*80  msg 
c
c       modify E,P following cpc p.364
c       get gzai for q~=gzai*p~
c       q0=sqrt(m**2 + gzai**2(p0**2-mu**2) )
c     
        p3(1) = Rpjcms   ! reooil proj.  in cms
        p3(2) = Rtgcms   ! recoil trgt.  in cms
        p3(3) = Missingp ! missing mass in cms
        roots = Cmsp.mass  

c           present mass
         amu(1)=Pjlab.mass
         amu(2)=Tglab.mass
         amu(3)=Missingp.mass  ! missing mass
c            

         csum0 = Pjlab.charge + Tglab.charge
         csum1 = Rpjcms.charge +Rtgcms.charge
         if( abs(csum1-csum0) .gt. 1) then
c                retry once more
            icon =1 
            goto 900
         else
            charge = csum0 - csum1
c             true mass    ! we want missing --> pion mass.
c             modify missing mass to be the pion mass
            call cmkptc(kpion, 0, charge, p3(3))
         endif   
c             get convesion factor
c          note: in cnbdcy, amu is not used, because 
c                it is always 0. (start from 0 mass ptcl)
c                and transform to massive case (true mass
c                is in /ptcl/ data.)
c                However, here, the trial mass is missing mass 
c                and must be given in amu. True mass is
c                in /ptcl/ p3
         call cnbdc3(3, roots, p3, amu, 1,
     *   gzai, icon)
         if(icon .eq. 0) then
             call cnbdc4(3, p3,  amu, 1, gzai)
c            ________________________________
c            write(*,*) ' p3 sumpx',
c    *       (p3(1).fm.p(1)+p3(2).fm.p(1)+p3(3).fm.p(1))
c            write(*,*) ' p3 sumpy',
c    *       (p3(1).fm.p(2)+p3(2).fm.p(2)+p3(3).fm.p(2))
c            write(*,*) ' p3 sumpz',
c    *       (p3(1).fm.p(3)+p3(2).fm.p(3)+p3(3).fm.p(3))
c            write(*,*) ' p3 sum e (gev)',
c    *       ( p3(1).fm.p(4)+p3(2).fm.p(4)+p3(3).fm.p(4))
c            write(*,*) ' roots=',roots
c            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c               reset leadings
             Rpjcms = p3(1)
             Rtgcms = p3(2)
c                boost  proj. recoil into lab (cms -> lab)
c                note:  tg(7).fm = cms 4 mom. in lab
             call cibst1(1, Cmsp, Rpjcms, Rpjlab)
c                boost target recoil into lab
             call cibst1(2, Cmsp, Rtgcms, Rtglab)
c               boost proj to target rest system. (may not be used)
             call cbst1(1, Tglab, Rpjlab, Rpjtatr)
c               same for projectile rest system. (may not be used)
             call cbst1(1, Pjlab, Rtglab, Rtgpatr)
c                move pion
             a(1) = p3(3)
             ntp = 1
         else
c            ____________________________________________
             write(msg,*) ' failed to adjust  missing mass=',
     *       Missingp.mass, ' into pion mass. consult k.k'
             call cerrorMsg(msg, 1)
c            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             ntp = 0
             icon = 1
         endif
 900     continue
       end
c     *********************************************************
      subroutine caspti
c     *********************************************************
c          preparation for assigning  pt
      implicit none
c----        include '../../Zptcl.h'
#include  "Zptcl.h"
c----        include '../../Zmass.h'
#include  "Zmass.h"
c----        include '../Zevhnv.h'
#include  "Zevhnv.h"
c
      real*8  efe0, xx
c      real*8  ptbase/330.d-3/
      real*8  ptbase/180.d-3/
c
c              some sort of effective E0, which I cannot
c           remember the reasoning now.
c        efe0 = (Efrs**2 + 2*(masn + Pjlab.mass)*Efrs)/2
c     *          /masn
        efe0 =max(1.d0,  (Efrs**2 - masn*2- Pjlab.mass**2)/2
     *          /masn)

c
c              Powerexp in   pt**pw2 * exp(-pt/..) dpt case.
        Powerexp=1.0d0 + (efe0)**(-0.05d0)
        if(efe0 .lt. 40.) then
           xx = (efe0 - 40.)/5.5 + 6.
           Ptnorm = ptbase *exp(xx)/(1+exp(xx))
        elseif(efe0 .lt. 40000.) then
           Ptnorm= ptbase
        else
           Ptnorm= ptbase
c           Ptnorm = ptbase *( efe0/40000.)**0.025
        endif
        Probpower=min(0.04d0*Nch, 0.33d0)  
        Powerp=3.d0 +
     *        1.d0/
     *     (0.01 + 0.01*3.29* Missingp.mass**0.3)
        if(Powerp .gt. 100.d0) then
             Probpower=0.d0
        endif
       end
c
c      *****************
       subroutine caspt(a, ntp)  
c           generation of pt
c      *****************
c----        include '../../Zptcl.h'
#include  "Zptcl.h"
c----        include '../../Zcode.h'
#include  "Zcode.h"
c----        include '../Zevhnv.h'
#include  "Zevhnv.h"
        integer ntp
        record /ptcl/ a(ntp)

        real*8  pttmp
        integer ntpc
c           <>pt for NN~,          DD~
c        real*8 ptnnb/500.d-3/, ptddb/750.d-3/, ptavpi/330.d-3/,
c     *         ptavk/479.d-3/, ptaveta/480.d-3/
        real*8 ptnnb/250.d-3/, ptddb/370.d-3/, ptavpi/180.d-3/,
     *         ptavk/240.d-3/, ptaveta/240.d-3/
c
        ntpc = 0
c                 (n,n~)
        pttmp=ptnnb* Ptnorm/ptavpi
c                     sample pt
        call cspt(pttmp, Nnnb, a, ntpc)

c                (d,d~)
        pttmp = ptddb* Ptnorm/ptavpi
        call cspt(pttmp, Nddb, a, ntpc)
c                 pi+/-
        pttmp=Ptnorm
        call cspt(pttmp, Npic,  a, ntpc)
c                 pi0
        call cspt(pttmp, Npi0,  a, ntpc)
c                eta
        pttmp = ptaveta*Ptnorm/ptavpi
        call cspt(pttmp, Neta, a, ntpc)
c                 kaon +/ -
        pttmp = ptavk*Ptnorm/ptavpi
        call cspt(pttmp, Nkch, a, ntpc)
c                 k0
        call cspt(pttmp, Nk0,  a, ntpc)
       end
c      ****************************************************
       subroutine ciso( ntp,  a, icon)
c           isotropic phase space
c          icon: 0---> o.k
c                1---> <pt> is big,   better to use cylindrical p.s
c                2---> n.g
c      ****************************************************
       implicit none
c----       include  '../../Zptcl.h'
#include  "Zptcl.h"
c----       include  '../Zevhnv.h'
#include  "Zevhnv.h"
       integer ntp, icon
       record /ptcl/   a(ntp)
c
       integer nc, jcon, i
       real*8 ptc1/500.d-3/, ptc2/700.d-3/
c
       real*8 ptlm1, ptlm2, missgm, wg, sumpt, avpt
c
       character*80  msg

       missgm = Missingp.mass
       nc=0
       if(Pjlab.fm.p(4) .lt. 1000.d0) then
             ptlm1=ptc1*(Pjlab.fm.p(4)/1000.d0)**0.04
             ptlm2=ptc2*(Pjlab.fm.p(4)/1000.d0)**0.04
       else
             ptlm1=ptc1
             ptlm2=ptc2
       endif
       if(3.1415/4.0* missgm/ntp .gt. ptlm1) then
             jcon=1
       else
c             *** until loop*** 
             do while (.true.)
c                  isotropic p.s decay; take almost all weights
c                  wg=.95 does not make any diff.(slower speed)
c                call cnbdcy(ntp, missgm, a, 1, wg, jcon)
                call cnbdcy(ntp, missgm, a, 0, wg, jcon)
                nc=nc+1
                if(nc .gt. 15) then
                    jcon=3
                    write(msg,*) ' cnbdcy fail but try further'
                    call cerrorMsg(msg, 1)
                endif
                if(jcon .ne. 0 .or. wg .gt. .05d0) goto 99
             enddo
   99        continue
             if(jcon .eq. 0) then
c                 boost 4 momentum into cms
                 do i=1, ntp
                    call cibst1(i, Missingp, a(i), a(i))
                 enddo
c                   get <pt> and see if it is too large
c                        get sum of  pt
                 sumpt=0.d0
                 do   i=1, ntp
                     sumpt=sumpt +
     *                  sqrt(a(i).fm.p(1)**2+a(i).fm.p(2)**2)
                 enddo
                 avpt=sumpt/ntp
                 if(avpt .gt. ptlm2) then
                    jcon = 2
                 elseif(avpt .gt. ptlm1) then
                    jcon = 1
                 else
                    jcon = 0
                 endif
             else
                 jcon = 2
             endif
         endif
         icon=jcon
      end
c     ***********************************************
c         convert rapidity y into to cms energy
c
      subroutine cytoe(a, n)
      implicit none
c----       include  '../../Zptcl.h'
#include  "Zptcl.h"
       integer n
       record /ptcl/ a(n)
c
       integer i
       real*8 etemp
          do   i=1, n
c              note that rap and e have the same pos.
c             etemp=a(i).fm.tm *  cosh( a(i).fm.rap  )
             etemp=a(i).fm.p(3)*  cosh( a(i).fm.p(4)  )
c             a(i).fm.p(3) = a(i).fm.tm * sinh( a(i).fm.rap )
             a(i).fm.p(3) = a(i).fm.p(3)* sinh( a(i).fm.p(4))
             a(i).fm.p(4) = etemp
          enddo
       end
c *****************************************************
      subroutine cspt(avpt,  nptcl, a, ntpc) 
c to sample a pt 
c avpt: real*8. Input. average pt in exponential part.  
c nptcl: integer. Input. # of ptcls to be assigned
c     a: /ptcl/.  output. a.fm.p(3) is given a pt value
c  ntpc: integer. input/oututp. a(ntpc+1) is the first
c                 ptcl pos.  ntpc is incremented by nptcl
c                 on return.

        implicit none
c----        include '../../Zptcl.h'
#include  "Zptcl.h"
c----        include '../Zevhnv.h'
#include  "Zevhnv.h"
        integer nptcl, ntpc
        record /ptcl/ a(*)
        real*8 avpt
c
c        real*8 u, bpt/1.7d0/, pt
c        real*8 u, bpt/1.5d0/, pt
        real*8 u, bpt/1.0d0/, pt

        integer nc
        
        do nc = 1, nptcl
           call rndc(u)
           if(u .lt. Probpower) then 
c                  power pt
                 call cspwpt(bpt, Powerp, pt)
           else 
c                   pt**pw2 * exp(-pt/..)dpt

                call ksgmrm(Powerexp, avpt, pt)
           endif
           ntpc = ntpc +1
           a(ntpc).fm.p(3) = pt
        enddo
        end
c       ***********************************************************
c 
c         dptcns: do forced conservation of pt * c
c       ***********************************************************
c 
c/usage/ call cptcns(a, nt, ptav) 
c 
c 1) compute sum of ptx and pty and distribute them to each ptcl 
c    propotionally to pt to have zero-sum ptx and pty.  
c 2) adjust pt, ptx, pty so that the sum of pt becomes the same 
c    values as that of original one 
c 
c a(nt) : /ptcl/. Input/Output.  
c ptav: real*8. Output.  <pt> 
c 
c 
c before calling this routine, pz should not be 
c set as z-component. it is the location of
c pt.
       subroutine cptcns(a, nt, ptav)
       implicit none
c----       include '../../Zptcl.h'
#include  "Zptcl.h"
       integer nt
       record /ptcl/ a(nt)
       real*8 ptav 
c
       real*8 sumpx, sumpy, sumpt, cfx, cfy
       real*8 sumpt2, cf
       integer i 
c
      if(nt .ge. 2) then 
c           get sum of pt, ptx, pty
         sumpx = 0.d0
         sumpy = 0.d0
         sumpt = 0.d0
         do i=1, nt
            sumpt = sumpt + a(i).fm.p(3)
            sumpx = sumpx + a(i).fm.p(1)
            sumpy = sumpy + a(i).fm.p(2)
         enddo
         if(sumpt .gt. 0.d0) then 
c              correction factor
            cfx=sumpx/sumpt
            cfy=sumpy/sumpt 
c
            sumpt2=0.d0
            do i=1, nt
               a(i).fm.p(1) = a(i).fm.p(1) - a(i).fm.p(3) * cfx
               a(i).fm.p(2) = a(i).fm.p(2) - a(i).fm.p(3) * cfy
               a(i).fm.p(3) = sqrt(a(i).fm.p(1)**2 + a(i).fm.p(2)**2 )
               sumpt2=a(i).fm.p(3) + sumpt2
            enddo 
c                adjust: sum (pt) = original value
            cf = sumpt/sumpt2 
c                  multipliy cf to pt and ptx,pty
            do i=1, nt
                a(i).fm.p(3) = a(i).fm.p(3)*cf
                a(i).fm.p(1) = a(i).fm.p(1)*cf
                a(i).fm.p(2) = a(i).fm.p(2)*cf
            enddo
            ptav=sumpt/nt
        else
            ptav = 1.d-1
        endif
      elseif(nt .gt. 0) then
         ptav=a(1).fm.p(3)
      else
         ptav = 1.d-1
      endif
      end 
