cc          Put data for  drawing  3D track image of hn collisions by gnuplot.
          implicit none

#include  "Zptcl.h"
#include  "Zcode.h"
#include  "Zevhnv.h"

          integer nmax
          parameter (nmax =2000)   ! # of max ptcls supposed to be generated
          record /ptcl/ pj, tg,  a(nmax)
c             projectile and target information (both befor
c             and after collision ) in different system.
c
          integer i, icon, ntp, j, nevent, nskip
          real*8  pabs

          real*4  x2, y2, z2
          real*4  ext/10./
          character*100  msg
c
          call cerrorMsg(
     *    'Nucleon proton collision: Enter next', 1)
          msg =
     *    '1) # of events; 2)# of events to be skipped'
     *   //' 3) incident elong rate(=10)'
          call cerrorMsg(msg, 1)
          read(*, *) nevent,  nskip, ext
          msg =
     *     ' Enter 3 momentum of incident proton'
          call cerrorMsg(msg, 1)
          read(*, *) pj.fm.p(1), pj.fm.p(2), pj.fm.p(3)
          msg =
     *     ' Enter 3 momentum of target proton'
          call cerrorMsg(msg, 1)
          read(*, *) tg.fm.p(1), tg.fm.p(2), tg.fm.p(3)
cc             make proton 
          call cmkptc(knuc, regptcl, 1,   pj)
          call cpm2e(pj, pj)
cc             make proton target
          call cmkptc(knuc, 0, 1,  tg)
          call cpm2e(tg, tg)
c          
          write(msg, *) '# pp col. events=', nevent, ' Ep(GeV)=',
     *     pj.fm.p(4), ' Et(GeV)=', tg.fm.p(4), ' skipped =', nskip
          call cerrorMsg(msg, 1)
          write(msg, *) '# 0, 0, 0, x, y, z,  code, charge '
          call cerrorMsg(msg, 1)
          call cerrorMsg(
     *    'Use gnuplot with "set para"; "splot filename w l"', 1)
c

          do i = 1, nskip
             call chncol(pj, tg, a, ntp, icon)
          enddo
          do i = 1, nevent
             
             call chncol(pj, tg, a, ntp, icon)
             if(icon .eq. 0) then
c                   draw incident.
                call cpxyzp(pj.fm, pabs)
                write(*, *) 0., 0., 0., pj.code, pj.charge
                if(pabs .eq. 0.) pabs = 1.
                x2 = -pj.fm.p(1)/pabs * ext
                y2 = -pj.fm.p(2)/pabs * ext
                z2 = -pj.fm.p(3)/pabs * ext
                write(*, *) x2, y2, z2, pj.code, pj.charge
                write(*, *)
                write(*, *)
c                   target
                call cpxyzp(tg.fm, pabs)
                if(pabs .eq. 0.) pabs = 1.
                write(*, *) 0., 0., 0., tg.code, tg.charge
                x2 = -tg.fm.p(1)/pabs * ext
                y2 = -tg.fm.p(2)/pabs * ext
                z2 = -tg.fm.p(3)/pabs * ext
                write(*, *) x2, y2, z2, tg.code, tg.charge
                write(*, *)
                write(*, *)
                do j=1, ntp
                   call cpxyzp(a(j).fm, pabs)
                   x2 = a(j).fm.p(1)/pabs
                   y2 = a(j).fm.p(2)/pabs
                   z2 = a(j).fm.p(3)/pabs
                   write(*, *) 0., 0., 0., a(j).code, a(j).charge
                   write(*, *) x2, y2, z2, a(j).code, a(j).charge
                   write(*, *)
                   write(*, *)
                enddo
             endif
          enddo   
        end
